Np=2^4;         %points in the T interval
dutycycle=Np/2; %for RZ pulse the pulse length
alfa=1;       %for raised cosine pulse
intervals=10;   %for raised cosine pulse
p0=1/2;         %0 probability
Il=2^12;        %information sequence length
ami=0;          %if 1 use AMI encoder, antipodal otherwise
use_scr=0;      %if 1 use the scrambler
gn=[0 3 5];lg=8;%scrambler generator; other pairs gn=[3];lg=3; gn=[0 3];lg=4;
                %gn=[0 3];lg=6; gn=[0 1 1];lg=7; gn=[0 5];lg=5;
add_noise=0;    %if 1 add noise and evaluate error rate
EbN0dB=8;       %Eb/N0 in dB; used if add noise
g=square_root_raised_cosine(alfa,Np,intervals);   
                %choices g=RZ(Np,dutycycle);g=manchester(Np); g=cosine(Np);
                %g=square_root_raised_cosine(alfa,Np,intervals);
plot_spectrum=1;%if 1, plot the power spectrum
if plot_spectrum
    new_plot=0; %if 0, plot over previous one
    color='b';  %character specifying the color
end
plot_eye=0;     %if 1 plot the eye; plot_eye and plot_spectrum cannot be both 1
%end data
if plot_spectrum*plot_eye, disp('wrong data'); return; end
if plot_spectrum
    Nr=10;      %realizations; this must be >=5
else
    if plot_eye
        Nr=1;   %this must be 1
    else
        Nr=5;
    end
end
response=conv(g,fliplr(g));
                %ideal response
[mr,ir]=max(response);
                %find the maximum, and its position
if add_noise
    EbN0=10^(EbN0dB/10);
    if ami
        if use_scr
            vn=(1-p0)/(2*EbN0);
        else
            vn=1/(4*EbN0);
        end
    else
        vn=1/(2*EbN0);
    end
end
Rm=[];
err=[]; errs=[];
for j=1:Nr
    x=zeros(Il,Np);
    info=rand(1,Il)>p0;
    if use_scr
        infos=scrambler(info,gn,lg);
    else
        infos=info;
    end
    if ami
        a=AMI(infos);
    else
        a=2*infos-1;
    end
    x(:,1)=a';
    x=reshape(x',1,Np*Il);
    st=conv(x,g);
    if add_noise
        noise=randn(1,length(st))*vn^0.5;
        sr=st+noise;
    else
        sr=st;
    end
    r=conv(fliplr(g),sr);
    Rm(j,:)=(abs(fft(r))).^2;
    if plot_eye
        figure
        for i=1:Il, plot(r(ir-Np/2+(i-1)*Np:ir-Np/2+i*Np),'r'); hold on; end
    end
    if ami
        dec=abs(r(ir:Np:ir+Np*(Il-1)))>0.5;
        llr=r(ir:Np:ir+Np*(Il-1));
    else
        dec=r(ir:Np:ir+Np*(Il-1))>0;
    end
    if ami 
        decs=vitdecode(llr,[1 2; 2 1],[0 1; 0 -1],length(llr),[1],length(llr));
    end
    if use_scr
        dec=scrambler(dec,gn,lg);
        if ami
            decs=scrambler(decs,gn,lg);
        end
    end
    err(j)=sum(xor(info,dec));
    if ami
        errs(j)=sum(xor(info,decs));
    end
end
if plot_spectrum
    plot_power_spectrum(mean(Rm),Np,new_plot,color);
end
if add_noise
    show_err=sprintf('mean error rate=%.2e',mean(err)/Il);
    disp(show_err);
    if ami
        show_err=sprintf('mean error rate soft=%.2e',mean(errs)/Il);
        disp(show_err);
    end
end