function [deco,am,at]=vitdecode(rec,ns,me,bits,pun,delay)
%function [deco,am,at]=vitdecode(rec,ns,me,bits,pun,delay)
%rec:   received sequence
%ns:    ns(i,j)=next state (i=actual state, j=input);
%me:    me(i,j)=associated output;
%bits:  information sequence length;
%pun:   puncturing pattern
%delay: decoding delay
%
%deco:  decoded sequence
%am:    accumulated metric
%at:    survided paths

states=size(ns,1);
inputs=size(ns,2);
outputs=size(me,3);
ppun=length(pun);

for s=1:states
  for i=1:inputs
    in(s,ns(s,i))=i;
  end
end
in;
am=zeros(1,states);

warning off
nam=ones(states,states)/0;
warning on

bit=0;
tbit=0;
for i=1:bits
 
  for as=1:states   %stato attuale
    for inp=1:2
      fs=ns(as,inp);
      nam(fs,as)=am(as);             
      tamp=0;
      abit=bit;
      for h=1:outputs
        if pun(rem(tbit+h-1,ppun)+1)
          abit=abit+1;
          tamp=tamp+(rec(abit)-me(as,inp,h))^2;
        end
      end
      nam(fs,as)=nam(fs,as)+tamp;             
    end
  end

  for h=1:outputs
    tbit=tbit+1; 
    if pun(rem(tbit-1,ppun)+1)
       bit=bit+1;
    end
  end

  nam;
  [a, b]=min(nam');
  iw=rem(i-1,delay)+1;
  ir=rem(i,delay)+1;

  if i == 1   
    for j=1:states, if(b(j)==1), am(j)=nam(j,b(j)); else, am(j)=100; end, ndec(j,:)=[in(b(j),j)]; end
  else
    clear ndec;
    for j=1:states, am(j)=nam(j,b(j)); dec(b(j),iw)=in(b(j),j); ndec(j,:)=dec(b(j),:); end 
  end
  dec=ndec;

  if i>=delay
    [a,b]=min(am);
    deco(i-delay+1)=dec(b,ir)-1;
  end
  ndec;
end

[a,b]=min(am);
for i=bits+1:bits+delay-1
  ir=rem(i,delay)+1;
  deco(i-delay+1)=dec(b,ir)-1;
end

at=dec-1;